// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.crypto.KeyRing is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * KeyRing contains multiple private and public keys.
 */
public final class KeyRing implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewKeyRing creates a new KeyRing, empty if key is nil.
	 */
	public KeyRing(Key key) {
		this.refnum = __NewKeyRing(key);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewKeyRing(Key key);
	
	KeyRing(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * FirstKeyID as obtained from API to match salt
	 */
	public final native String getFirstKeyID();
	/**
	 * FirstKeyID as obtained from API to match salt
	 */
	public final native void setFirstKeyID(String v);
	
	/**
	 * AddKey adds the given key to the keyring.
	 */
	public native void addKey(Key key) throws Exception;
	/**
	 * CanEncrypt returns true if any of the keys in the keyring can be used for encryption.
	 */
	public native boolean canEncrypt();
	/**
	 * CanVerify returns true if any of the keys in the keyring can be used for verification.
	 */
	public native boolean canVerify();
	public native void clearPrivateParams();
	/**
	 * Copy creates a deep copy of the keyring.
	 */
	public native KeyRing copy() throws Exception;
	/**
	 * CountDecryptionEntities returns the number of entities in the keyring.
	 */
	public native long countDecryptionEntities();
	/**
	 * CountEntities returns the number of entities in the keyring.
	 */
	public native long countEntities();
	/**
	 * Decrypt decrypts encrypted string using pgp keys, returning a PlainMessage
	* message    : The encrypted input as a PGPMessage
	* verifyKey  : Public key for signature verification (optional)
	* verifyTime : Time at verification (necessary only if verifyKey is not nil)
	
	When verifyKey is not provided, then verifyTime should be zero, and
	signature verification will be ignored.
	 */
	public native PlainMessage decrypt(PGPMessage message, KeyRing verifyKey, long verifyTime) throws Exception;
	public native PlainMessage decryptAttachment(PGPSplitMessage message) throws Exception;
	/**
	 * DecryptMIMEMessage decrypts a MIME message.
	 */
	public native void decryptMIMEMessage(PGPMessage message, KeyRing verifyKey, MIMECallbacks callbacks, long verifyTime);
	/**
	 * DecryptSessionKey returns the decrypted session key from one or multiple binary encrypted session key packets.
	 */
	public native SessionKey decryptSessionKey(byte[] keyPacket) throws Exception;
	/**
	 * DecryptSplitStream is used to decrypt a split pgp message as a Reader.
	It takes a key packet and a reader for the data packet
	and returns a PlainMessageReader for the plaintext data.
	If verifyKeyRing is not nil, PlainMessageReader.VerifySignature() will
	verify the embedded signature with the given key ring and verification time.
	 */
	public native PlainMessageReader decryptSplitStream(byte[] keypacket, Reader dataPacketReader, KeyRing verifyKeyRing, long verifyTime) throws Exception;
	/**
	 * DecryptStream is used to decrypt a pgp message as a Reader.
	It takes a reader for the message data
	and returns a PlainMessageReader for the plaintext data.
	If verifyKeyRing is not nil, PlainMessageReader.VerifySignature() will
	verify the embedded signature with the given key ring and verification time.
	 */
	public native PlainMessageReader decryptStream(Reader message, KeyRing verifyKeyRing, long verifyTime) throws Exception;
	/**
	 * Encrypt encrypts a PlainMessage, outputs a PGPMessage.
	If an unlocked private key is also provided it will also sign the message.
	* message    : The plaintext input as a PlainMessage.
	* privateKey : (optional) an unlocked private keyring to include signature in the message.
	 */
	public native PGPMessage encrypt(PlainMessage message, KeyRing privateKey) throws Exception;
	public native PGPSplitMessage encryptAttachment(PlainMessage message, String filename) throws Exception;
	/**
	 * EncryptSessionKey encrypts the session key with the unarmored
	publicKey and returns a binary public-key encrypted session key packet.
	 */
	public native byte[] encryptSessionKey(SessionKey sk) throws Exception;
	/**
	 * EncryptSplitStream is used to encrypt data as a stream.
	It takes a writer for the Symmetrically Encrypted Data Packet
	(https://datatracker.ietf.org/doc/html/rfc4880#section-5.7)
	and returns a writer for the plaintext data and the key packet.
	If signKeyRing is not nil, it is used to do an embedded signature.
	 */
	public native EncryptSplitResult encryptSplitStream(Writer dataPacketWriter, PlainMessageMetadata plainMessageMetadata, KeyRing signKeyRing) throws Exception;
	/**
	 * EncryptStream is used to encrypt data as a Writer.
	It takes a writer for the encrypted data and returns a WriteCloser for the plaintext data
	If signKeyRing is not nil, it is used to do an embedded signature.
	 */
	public native WriteCloser encryptStream(Writer pgpMessageWriter, PlainMessageMetadata plainMessageMetadata, KeyRing signKeyRing) throws Exception;
	/**
	 * EncryptWithCompression encrypts with compression support a PlainMessage to PGPMessage using public/private keys.
	* message : The plain data as a PlainMessage.
	* privateKey : (optional) an unlocked private keyring to include signature in the message.
	* output  : The encrypted data as PGPMessage.
	 */
	public native PGPMessage encryptWithCompression(PlainMessage message, KeyRing privateKey) throws Exception;
	/**
	 * FirstKey returns a KeyRing with only the first key of the original one.
	 */
	public native KeyRing firstKey() throws Exception;
	// skipped method KeyRing.GetIdentities with unsupported parameter or return types
	
	/**
	 * GetKey returns the n-th openpgp key contained in this KeyRing.
	 */
	public native Key getKey(long n) throws Exception;
	// skipped method KeyRing.GetKeyIDs with unsupported parameter or return types
	
	// skipped method KeyRing.GetKeys with unsupported parameter or return types
	
	/**
	 * GetVerifiedSignatureTimestamp verifies a PlainMessage with a detached PGPSignature
	returns the creation time of the signature if it succeeds
	and returns a SignatureVerificationError if fails.
	 */
	public native long getVerifiedSignatureTimestamp(PlainMessage message, PGPSignature signature, long verifyTime) throws Exception;
	public native AttachmentProcessor newLowMemoryAttachmentProcessor(long estimatedSize, String filename) throws Exception;
	public native ManualAttachmentProcessor newManualAttachmentProcessor(long estimatedSize, String filename, byte[] dataBuffer) throws Exception;
	/**
	 * SignDetached generates and returns a PGPSignature for a given PlainMessage.
	 */
	public native PGPSignature signDetached(PlainMessage message) throws Exception;
	/**
	 * SignDetachedEncrypted generates and returns a PGPMessage
	containing an encrypted detached signature for a given PlainMessage.
	 */
	public native PGPMessage signDetachedEncrypted(PlainMessage message, KeyRing encryptionKeyRing) throws Exception;
	/**
	 * SignDetachedEncryptedStream generates and returns a PGPMessage
	containing an encrypted detached signature for a given message Reader.
	 */
	public native PGPMessage signDetachedEncryptedStream(Reader message, KeyRing encryptionKeyRing) throws Exception;
	/**
	 * SignDetachedStream generates and returns a PGPSignature for a given message Reader.
	 */
	public native PGPSignature signDetachedStream(Reader message) throws Exception;
	/**
	 * VerifyDetached verifies a PlainMessage with a detached PGPSignature
	and returns a SignatureVerificationError if fails.
	 */
	public native void verifyDetached(PlainMessage message, PGPSignature signature, long verifyTime) throws Exception;
	/**
	 * VerifyDetachedEncrypted verifies a PlainMessage
	with a PGPMessage containing an encrypted detached signature
	and returns a SignatureVerificationError if fails.
	 */
	public native void verifyDetachedEncrypted(PlainMessage message, PGPMessage encryptedSignature, KeyRing decryptionKeyRing, long verifyTime) throws Exception;
	/**
	 * VerifyDetachedEncryptedStream verifies a PlainMessage
	with a PGPMessage containing an encrypted detached signature
	and returns a SignatureVerificationError if fails.
	 */
	public native void verifyDetachedEncryptedStream(Reader message, PGPMessage encryptedSignature, KeyRing decryptionKeyRing, long verifyTime) throws Exception;
	/**
	 * VerifyDetachedStream verifies a message reader with a detached PGPSignature
	and returns a SignatureVerificationError if fails.
	 */
	public native void verifyDetachedStream(Reader message, PGPSignature signature, long verifyTime) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof KeyRing)) {
		    return false;
		}
		KeyRing that = (KeyRing)o;
		String thisFirstKeyID = getFirstKeyID();
		String thatFirstKeyID = that.getFirstKeyID();
		if (thisFirstKeyID == null) {
			if (thatFirstKeyID != null) {
			    return false;
			}
		} else if (!thisFirstKeyID.equals(thatFirstKeyID)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getFirstKeyID()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("KeyRing").append("{");
		b.append("FirstKeyID:").append(getFirstKeyID()).append(",");
		return b.append("}").toString();
	}
}

